
Global $alldone
Global $changeddone
Global $filereadline
Global $fileopen
Global $theendbox
Global $filereadlinesplit

#include <File.au3>

#cs

A more advanced version of the script that compares what is currently in the segment with what is to be pasted, and if it is the same, then it doesn't paste (thereby not affecting the segment status).

#ce


#cs

Version 4 is an update to version 2. Version 5 is an update to version 3.  Version 4 blindly replaces whatever is in the target field with the line from the input file.  Version 5 compares the line from the input file with what is currently in the target field, and replaces it only if it is different (this means that the status of the segment doesn't get updated if the translation doesn't change).  Version 4 is faster, obviously.

#ce



HotKeySet ("{ESC}", "TheEnd")

While 1

MsgBox (0, "Idiot2Desktop version 5", "Idiot2Desktop  is a script that pastes lines of text from an input file into Idiom Desktop.  The input file is plaintext UTF8, with one segment per line.  Don't run this script while you're not looking at the screen -- check visually if it pastes the right stuff in the right place.  Remember, you can abort the script with 'Escape' and then undo your last changes using Ctrl+Z.  Version 5 compares the current target text with the text from the input file, and if it is different, it replaces the current target text with the text from the input file.  Version 5 is slower than version 4, but it will not cause segments' status to get updated unless the content has actually changed.", 0)

$fileopen = FileOpenDialog ("Select input file", "@ScriptDir", "All (*.*)|Text files (*.txt)")
FileOpen ($fileopen, 128)
$filecountlines = _FileCountLines ($fileopen)

MsgBox (0, "Click in Idiom!", "Ready? Click with your mouse in the first line in Idiom... you have 5 seconds!", 5)

Sleep ("5000") ; so actually you have 10 seconds...

WinWaitActive ("Idiom WorldServer", "")

$alldone = 0
$changeddone = 0

For $i = 1 to $filecountlines

WinWaitActive ("Idiom WorldServer", "")

$filereadline = FileReadLine ($fileopen, $i)

$filereadlinesplit = StringSplit ($filereadline, @TAB, 1)

If $filereadlinesplit[0] <> 2 Then
$SLterm = "!!!!!!!!!!"
$TLterm = "!!!!!!!!!!"
Else
$SLterm = $filereadlinesplit[1]
$TLterm = $filereadlinesplit[2]
EndIf



Send ("^a")
Sleep ("50")
Send ("^x")
Sleep ("100")
$existingtext = ClipGet()
Sleep ("100")

Send ("{F5}")
Sleep ("50")
Send ("^x")
Sleep ("100")
$sourcetext = ClipGet()
Sleep ("100")

Send ("^z")
Sleep ("50")

If $sourcetext <> $SLterm Then
ClipPut ($TLterm)
MsgBox (0, "Mismatch!", "Idiom's source text = " & $sourcetext & @CRLF & "Text file's source text = " & $SLterm & @CRLF & "Text file's target text (on clipboard) = " & $TLterm, 0) 

Else ; If $sourcetext == $SLterm

If $existingtext == $TLterm Then
Send ("^a")
Sleep ("50")
Send ("{DOWN}")
Else ; If $existingtext <> $TLterm Then
ClipPut ($TLterm)
Sleep ("50")
Send ("^a")
Sleep ("50")
Send ("^v")
Sleep ("50")
Send ("{DOWN}")
Sleep ("50")
$changeddone = $changeddone + 1
; Else
; MsgBox (0, "Comparison failed", "Comparison failed", 0)
; Exit
EndIf

EndIf

$alldone = $alldone + 1

Next

MsgBox (0, "Done!", "Did " & $alldone & " segments, of which " & $changeddone & " changed.", 10)
Exit

WEnd

Func TheEnd()
$theendbox = MsgBox (1, "Paused...", "Did " & $alldone & " segments so far, of which " & $changeddone & " changed." & @CRLF & @CRLF & "Do you wish to continue? Click 'OK' to continue, or click 'Cancel' to exit.", 0)

If $theendbox = 2 Then
Exit
EndIf

MsgBox (0, "Click in Idiom!", "Click with your mouse where you had paused... you have 5 seconds!", 5)

Sleep ("5000") ; so yes you have 10 seconds
EndFunc





